//---------------------------------------------------------------------------


#pragma hdrstop

#include "MyShockwaveFlashCPP.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
__fastcall TMyShockwaveFlash::TMyShockwaveFlash(TComponent* AOwner)
: TShockwaveFlash(AOwner)
{
  FStream = new TMemoryStream;
}
//---------------------------------------------------------------------------
__fastcall TMyShockwaveFlash::~TMyShockwaveFlash()
{
  DoneFlash();
  delete FStream;
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::WriteFlash(TStream* Stream)
{
  int v = FStream->Size;
  Stream->WriteBuffer(&v, sizeof(v));
  FStream->Position = 0;
  Stream->CopyFrom(FStream, v);
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::ReadFlash(TStream* Stream)
{
  int v;
  Stream->ReadBuffer(&v, sizeof(v));
  if (v>0)
  {
    FStream->SetSize(0);
    FStream->CopyFrom(Stream, v);
  }
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::DefineProperties(TFiler* Filer)
{
  TShockwaveFlash::DefineProperties(Filer);
  Filer->DefineBinaryProperty("FlashMovie", ReadFlash, WriteFlash, FStream->Size>0);
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::Loaded()
{
  TShockwaveFlash::Loaded();
  if (FStream->Size>0)
    InitFlash();
}
//---------------------------------------------------------------------------
bool __fastcall TMyShockwaveFlash::LoadFlash(const AnsiString FileName)
{
  bool r = false;
  try
  {
    TFileStream* fs = new TFileStream(FileName, fmOpenRead);
    FStream->SetSize(0);
    FStream->CopyFrom(fs, fs->Size);
    delete fs;
    r = true;
  }
  catch(...)
  {
  }
  return r;
}
//---------------------------------------------------------------------------
bool __fastcall TMyShockwaveFlash::LoadFlashFromStream(TStream* Stream)
{
  bool r = false;
  try
  {
    FStream->SetSize(0);
    Stream->Position = 0;
    FStream->CopyFrom(Stream, Stream->Size);
    r = true;
  }
  catch(...)
  {
  }
  return r;
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::SaveFlash(const AnsiString FileName)
{
  TFileStream* fs = new TFileStream(FileName, fmCreate);
  __try
  {
    FStream->Position = 0;
    fs->CopyFrom(FStream, FStream->Size);
  }
  __finally
  {
    delete fs;
  }
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::SaveFlashToStream(TStream* Stream)
{
  FStream->Position = 0;
  Stream->Size = 0;
  Stream->CopyFrom(FStream, FStream->Size);
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::SetFlash(TMyShockwaveFlash* Source)
{
  FStream->SetSize(0);
  Source->FStream->Position = 0;
  FStream->CopyFrom(Source->FStream, Source->FStream->Size);
}
//---------------------------------------------------------------------------
bool __fastcall TMyShockwaveFlash::InitFlash()
{
  bool r = false;
  try
  {
    FTmpFileName.SetLength(1000);
    int l = GetTempPath(1000, FTmpFileName.c_str());
    FTmpFileName.SetLength(l);
    if (FTmpFileName.Length()>0 && FTmpFileName[FTmpFileName.Length()]!='\\')
      FTmpFileName = FTmpFileName+"\\";
    l = random(1000);
    while (FileExists(FTmpFileName+IntToStr(l)+".swf"))
      l++;
    FTmpFileName = FTmpFileName+IntToStr(l)+".swf";
    TFileStream* fs = new TFileStream(FTmpFileName, fmCreate);
    __try
    {
    FStream->Position = 0;
    fs->CopyFrom(FStream, FStream->Size);
    }
    __finally
    {
      delete fs;
    }
    Movie = FTmpFileName;
    r = True;
  }
  catch(...)
  {
  }
  return r;
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::Reload()
{
  Stop();
  Movie = FTmpFileName;
  if (FTmpFileName!="")
    Play();
}
//---------------------------------------------------------------------------
void __fastcall TMyShockwaveFlash::DoneFlash()
{
  Stop();
  DeleteFile(FTmpFileName);
  FTmpFileName = "";
}

namespace Myshockwaveflashcpp
{

void __fastcall PACKAGE Register()
{
  TComponentClass cls_svr[] = { __classid(TMyShockwaveFlash), __classid(TMyShockwaveFlashTest) };
  RegisterComponents("ActiveX", cls_svr, sizeof(cls_svr)/sizeof(cls_svr[0])-1);
}
};

